<?php

declare(strict_types=1);

namespace Dedi\SyliusMarketingPlugin\Factory;

use Dedi\SyliusMarketingPlugin\Storage\EventsBag;
use Symfony\Component\HttpFoundation\Session\SessionFactoryInterface;
use Symfony\Component\HttpFoundation\Session\SessionInterface;

class EventsBagSessionFactory implements SessionFactoryInterface
{
    private SessionFactoryInterface $delegate;
    private EventsBag $eventsBag;

    public function __construct(SessionFactoryInterface $delegate, EventsBag $eventsBag)
    {
        $this->delegate = $delegate;
        $this->eventsBag = $eventsBag;
    }

    public function createSession(): SessionInterface
    {
        $session = $this->delegate->createSession();
        $session->registerBag($this->eventsBag);

        return $session;
    }
}
